; main.s
; Desenvolvido para a placa EK-TM4C1294XL
; Exemplo de uso de GPIO ...
; Prof. Guilherme de S. Peron	- 12/03/2018
; Prof. Marcos E. P. Monteiro	- 12/03/2018
; Prof. DaLuz           		- 25/02/2022

;################################################################################

; Este programa espera o usurio apertar a chave USR_SW1 e/ou a chave USR_SW2.
; Caso o usurio pressione a chave USR_SW1, acender o LED3 (PF4). Caso o usurio pressione 
; a chave USR_SW2, acender o LED4 (PF0). Caso as duas chaves sejam pressionadas, os dois 
; LEDs acendem.

;################################################################################
	THUMB											; Instrues do tipo Thumb-2
;################################################################################
; Definies dos Registradores Gerais.  Obs: *(EQU)=(EQUATE)*
;<NOME>	EQU	<VALOR>
;################################################################################
; rea de Dados - Declaraes de variveis
	AREA  DATA, ALIGN=2
	; Se alguma varivel for chamada em outro arquivo
	;EXPORT  <var> [DATA,SIZE=<tam>]   	; Permite chamar a varivel <var> a 
		                                ; partir de outro arquivo
;<var>	SPACE <tam>                     ; Declara uma varivel de nome <var>
                                        ; de <tam> bytes a partir da primeira 
                                        ; posio da RAM		
;################################################################################
; rea de Cdigo - Tudo abaixo da diretiva a seguir ser armazenado na memria de 
;                  cdigo
	AREA    |.text|, CODE, READONLY, ALIGN=2
	; Se alguma funo do arquivo for chamada em outro arquivo	
    EXPORT Start                		; Permite chamar a funo Start a partir de 
										; outro arquivo. No caso startup.s
	; Se chamar alguma funo externa	
	;IMPORT <func>              		; Permite chamar dentro deste arquivo uma 
										; funo <func>
	IMPORT  GPIO_Init
    IMPORT  PortF_Output
    IMPORT  PortJ_Input
;################################################################################
; Funo main()
Start  			
	BL 		GPIO_Init					;Chama a subrotina que inicializa os GPIO

MainLoop
	BL 		PortJ_Input				 	;Chama a subrotina que l o estado das chaves e coloca o resultado em R0
Verifica_Nenhuma
	CMP		R0, #2_00000011			 	;Verifica se nenhuma chave est pressionada
	BNE		Verifica_SW1			 	;Se o teste viu que tem pelo menos alguma chave pressionada pula
	MOV 	R0, #0                   	;No acender nenhum LED
	BL		PortF_Output			 	;Chamar a funo para no acender nenhum LED
	B		MainLoop					;Se o teste viu que nenhuma chave est pressionada, volta para o lao principal
Verifica_SW1	
	CMP		R0, #2_00000010			 	;Verifica se somente a chave SW1 est pressionada
	BNE		Verifica_SW2             	;Se o teste falhou, pula
	MOV		R0, #2_00010000			 	;Setar o parmetro de entrada da funo como o BIT4
	BL		PortF_Output				;Chamar a funo para setar o LED3
	B		MainLoop                   	;Volta para o lao principal
Verifica_SW2	
	CMP		R0, #2_00000001			 	;Verifica se somente a chave SW2 est pressionada
	BNE		Verifica_Ambas           	;Se o teste falhou, pula
	MOV		R0, #2_00000001			 	;Setar o parmetro de entrada da funo como o BIT0
	BL		PortF_Output				;Chamar a funo para setar o LED4
	B		MainLoop                   	;Volta para o lao principal	
Verifica_Ambas
	CMP		R0, #2_00000000			 	;Verifica se ambas as chaves esto pressionadas
	BNE		MainLoop          		 	;Se o teste falhou, pula
	MOV		R0, #2_00010001			 	;Setar o parmetro de entrada da funo como o BIT0e o BIT4
	BL		PortF_Output		  	 	;Chamar a funo para acender os dois LEDs
	B		MainLoop                   	;Volta para o lao principal	

    ALIGN                        		;Garante que o fim da seo est alinhada 
    END                          		;Fim do arquivo